#version 330

layout(location = 0) in vec4 position;
layout(location = 1) in vec2 texCoords;
layout(location = 2) in vec3 normals;


layout(std140) uniform GlobalMatrices
{
	uniform mat4 perspectiveViewMatrix;
	uniform vec2 windowDimensions;
};

uniform mat4 modelMatrix;
uniform mat4 viewMatrix;
//uniform vec3 vLightPosition;

smooth out vec2 vVaryingTexCoord;
smooth out vec3 vVaryingNormal;
smooth out vec3 vVaryingLightDir;


void main(void) 
{
    // Pass on the texture coordinates 
    vVaryingTexCoord = texCoords;

    // Get surface normal in eye coordinates
    mat4 MV = modelMatrix;
	mat4 itMV = transpose(inverse(MV));	

	vec4 normal = vec4(0.0, 0.0, 0.0, 0.0);
	normal.xyz = normals.xyz;

	vVaryingNormal = (itMV * normal).xyz;

    // Get vertex position in eye coordinates
    vec4 vPosition4 = MV * position;
	vec3 vPosition3 = vPosition4.xyz / vPosition4.w;

    // Get vector to light source
    vec3 vLightPosition = vec3(0.0f, 10.0f, 0.0f);
	vVaryingLightDir = normalize(vLightPosition - vPosition3);


    // Don't forget to transform the geometry!
    gl_Position =perspectiveViewMatrix * modelMatrix * position;
}